<script>
  import back from "../../plugins/axios";

  let date = new Date();
  let input = {
    jour: date.getDate(),
    mois: date.getMonth() + 1,
    annee: date.getFullYear(),
    heure: date.getHours(),
    minute: date.getMinutes(),
    seconde: date.getSeconds(),
  };
  let alert = "";
  let success = "";

  back.get("/website/dates/start").then((res) => {
    date = new Date(res.data.start_date);
    input = {
      jour: date.getDate(),
      mois: date.getMonth() + 1,
      annee: date.getFullYear(),
      heure: date.getHours(),
      minute: date.getMinutes(),
      seconde: date.getSeconds(),
    };
  });

  function update() {
    // convert date to string with format 2023-02-03T18:00:00+01:00 and add 0 if needed
    let date_string =
      input.annee +
      "-" +
      (input.mois < 10 ? "0" + input.mois : input.mois) +
      "-" +
      (input.jour < 10 ? "0" + input.jour : input.jour) +
      "T" +
      (input.heure < 10 ? "0" + input.heure : input.heure) +
      ":" +
      (input.minute < 10 ? "0" + input.minute : input.minute) +
      ":" +
      (input.seconde < 10 ? "0" + input.seconde : input.seconde) +
      "+01:00";
    back.put("/website/dates/start", { date: date_string }).then((res) => {
      if (res.status == 200) {
        date = new Date(res.data.date);
        success = "La date de début de l'évènement a été mise à jour.";
      } else {
        alert = "Une erreur est survenue";
      }
      setTimeout(() => {
        success = "";
        alert = "";
      }, 5000);
    });
  }
</script>

<div class="w-full h-full max-w-md items-center self-center">
  <form
    class="bg-secondary h-full shadow-md items-center rounded px-8 pt-6 pb-8 mb-4"
    on:submit|preventDefault={update}
  >
    <!-- alert & success -->
    {#if alert}
      <div
        class="bg-red-100 border border-red-400 text-red-700 px-4 py-3 rounded relative mt-2 mb-2"
        role="alert"
      >
        <strong class="font-bold">Erreur !</strong>
        <span class="block sm:inline">{alert}</span>
      </div>
    {/if}
    {#if success}
      <div
        class="bg-green-100 border border-green-400 text-green-700 px-4 py-3 rounded relative mt-2 mb-2"
        role="alert"
      >
        <strong class="font-bold">Succès !</strong>
        <span class="block sm:inline">{success}</span>
      </div>
    {/if}
    <div class="mb-4">
      <label class="block text-gray-700 text-sm font-bold mb-2" for="name">
        Début de l'évènement
      </label>
      <!-- inputs for jour, mois, annee, heure, minutes, secondes -->
      <div class="flex flex-row">
        <div class="flex flex-col mr-2">
          <label class="block text-gray-700 text-sm font-bold mb-2" for="name">
            Jour
          </label>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
            id="jour"
            type="number"
            min="1"
            max="31"
            bind:value={input.jour}
            on:change={() => {
              date.setDate(input.jour);
            }}
          />
        </div>
        <div class="flex flex-col mr-2">
          <label class="block text-gray-700 text-sm font-bold mb-2" for="name">
            Mois
          </label>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
            id="mois"
            type="number"
            min="1"
            max="12"
            bind:value={input.mois}
            on:change={() => {
              date.setMonth(input.mois - 1);
            }}
          />
        </div>
        <div class="flex flex-col mr-2">
          <label class="block text-gray-700 text-sm font-bold mb-2" for="name">
            Année
          </label>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
            id="annee"
            type="number"
            min="2020"
            max="2100"
            bind:value={input.annee}
            on:change={() => {
              date.setFullYear(input.annee);
            }}
          />
        </div>
      </div>
      <div class="flex flex-row">
        <div class="flex flex-col mr-2">
          <label class="block text-gray-700 text-sm font-bold mb-2" for="name">
            Heure
          </label>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
            id="heure"
            type="number"
            min="0"
            max="23
                "
            bind:value={input.heure}
            on:change={() => {
              date.setHours(input.heure);
            }}
          />
        </div>
        <div class="flex flex-col mr-2">
          <label class="block text-gray-700 text-sm font-bold mb-2" for="name">
            Minutes
          </label>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
            id="heure"
            type="number"
            min="0"
            max="23
                "
            bind:value={input.minute}
            on:change={() => {
              date.setHours(input.minute);
            }}
          />
        </div>
        <div class="flex flex-col mr-2">
          <label class="block text-gray-700 text-sm font-bold mb-2" for="name">
            Secondes
          </label>
          <input
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
            id="heure"
            type="number"
            min="0"
            max="23
                "
            bind:value={input.seconde}
            on:change={() => {
              date.setHours(input.seconde);
            }}
          />
        </div>
      </div>

      <div class="flex items-center justify-between mt-5">
        <button
          class="bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-4 rounded focus:outline-none focus:shadow-outline"
          type="button"
          on:click={update}
        >
          Envoyer
        </button>
      </div>
    </div>
  </form>
</div>
